' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2006                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : K.Yakushinji
'
'  : 2006/12/01 
' -----------------------------------------------------------------

Imports FVDATASLib
Public Class frmMain

    Private m_blnVideoOpened As Boolean         'rfIfoCXI[vĂ邩
    Private m_strVideoConfFilePath As String    'rfIݒt@CitpXj    
    Private m_blnCanHWBinarize As Boolean       'HWQl\ǂ
    Private m_bCanOffSet As Boolean             'ItZbg\ǂ
    Private m_bCanExposure As Boolean           'IԂ\ǂ
    Private m_bInsFreerun As Boolean            't[ǂ

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Timer1.Stop()

        If m_blnVideoOpened Then
            'rfIfoCXI[vĂꍇ̓N[Y܂
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'rfIfoCX̃I[vԕێϐ̏
        m_blnVideoOpened = False
        btnGrab.Enabled = False
        btnFreerun.Enabled = False

        'gp̊mF
        If My.Forms.frmLicence.ShowDialog() <> Windows.Forms.DialogResult.Yes Then
            End
        End If

        'rfIfoCXI
        setVideoConfFile()

    End Sub

    'EBhETCYύXꂽƂ̏
    Private Sub frmMain_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize

        Dim newSize As New Size
        Dim newLocation As New Point

        newSize.Width = (Me.Width - AxFvxDisplayEx1.Left - 25) / 2
        newSize.Height = (Me.Height - AxFvxDisplayEx1.Top - 50) / 2
        AxFvxDisplayEx1.Size = newSize
        AxFvxDisplayEx2.Size = newSize
        AxFvxDisplayEx3.Size = newSize
        AxFvxDisplayEx4.Size = newSize

        newLocation.X = AxFvxDisplayEx1.Location.X + AxFvxDisplayEx1.Size.Width + 15
        newLocation.Y = AxFvxDisplayEx1.Location.Y
        AxFvxDisplayEx2.Location = newLocation

        newLocation.X = AxFvxDisplayEx1.Location.X
        newLocation.Y = AxFvxDisplayEx1.Size.Height + 20
        AxFvxDisplayEx3.Location = newLocation

        newLocation.X = AxFvxDisplayEx2.Location.X
        newLocation.Y = AxFvxDisplayEx3.Location.Y
        AxFvxDisplayEx4.Location = newLocation

    End Sub

    'AScope\؂ւ
    Private Sub chkAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkAScope.CheckedChanged

        If chkAScope.Checked = True Then
            AxFvxDisplayEx1.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeAuto
            AxFvxDisplayEx2.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeAuto
            AxFvxDisplayEx3.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeAuto
            AxFvxDisplayEx4.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeAuto
        Else
            AxFvxDisplayEx1.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeDisable
            AxFvxDisplayEx2.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeDisable
            AxFvxDisplayEx3.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeDisable
            AxFvxDisplayEx4.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeDisable
        End If

    End Sub

    '\{minus
    Private Sub btnDispMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispMinus.Click

        AxFvxDisplayEx1.Magnification = AxFvxDisplayEx1.Magnification - 0.5
        AxFvxDisplayEx2.Magnification = AxFvxDisplayEx1.Magnification
        AxFvxDisplayEx3.Magnification = AxFvxDisplayEx1.Magnification
        AxFvxDisplayEx4.Magnification = AxFvxDisplayEx1.Magnification

        If AxFvxDisplayEx1.Magnification <= 0.5 Then
            btnDispMinus.Enabled = False
        Else
            btnDispMinus.Enabled = True
        End If
        btnDispPlus.Enabled = True

    End Sub

    '\{plus
    Private Sub btnDispPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispPlus.Click
        AxFvxDisplayEx1.Magnification = AxFvxDisplayEx1.Magnification + 0.5
        AxFvxDisplayEx2.Magnification = AxFvxDisplayEx1.Magnification
        AxFvxDisplayEx3.Magnification = AxFvxDisplayEx1.Magnification
        AxFvxDisplayEx4.Magnification = AxFvxDisplayEx1.Magnification

        If AxFvxDisplayEx1.Magnification > 10.0# Then
            btnDispPlus.Enabled = False
        Else
            btnDispPlus.Enabled = True
        End If
        btnDispMinus.Enabled = True

    End Sub

    '{\
    Private Sub btnDisp1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisp1.Click

        AxFvxDisplayEx1.Magnification = 1
        AxFvxDisplayEx2.Magnification = 1
        AxFvxDisplayEx3.Magnification = 1
        AxFvxDisplayEx4.Magnification = 1

        btnDispPlus.Enabled = True
        btnDispMinus.Enabled = True

    End Sub

    'tʕ\
    Private Sub btnDispFull_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispFull.Click

        Dim dblScaleX As Double
        Dim dblScaleY As Double

        dblScaleX = AxFvxDisplayEx1.Width / AxFvxImage1.ImageWidth
        dblScaleY = AxFvxDisplayEx1.Height / AxFvxImage1.ImageHeight

        If dblScaleX < dblScaleY Then
            AxFvxDisplayEx1.Magnification = dblScaleX
            AxFvxDisplayEx2.Magnification = dblScaleX
            AxFvxDisplayEx3.Magnification = dblScaleX
            AxFvxDisplayEx4.Magnification = dblScaleX
        Else
            AxFvxDisplayEx1.Magnification = dblScaleY
            AxFvxDisplayEx2.Magnification = dblScaleY
            AxFvxDisplayEx3.Magnification = dblScaleY
            AxFvxDisplayEx4.Magnification = dblScaleY
        End If

        btnDispPlus.Enabled = True
        btnDispMinus.Enabled = True

    End Sub

    '\摜ۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click
        SaveFileDialog1.InitialDirectory = Application.StartupPath
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then

            Try
                AxFvxImage1.CurrentNo = 0
                AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName().Replace(".bmp", "_0.bmp")
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
                AxFvxImage1.CurrentNo = 1
                AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName().Replace(".bmp", "_1.bmp")
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
                AxFvxImage1.CurrentNo = 2
                AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName().Replace(".bmp", "_2.bmp")
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
                AxFvxImage1.CurrentNo = 3
                AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName().Replace(".bmp", "_3.bmp")
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
            Catch
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" + intErr.ToString() + ")", vbExclamation, "ۑs")
            End Try
        End If

    End Sub

    'rfIݒt@C̍Đݒ
    Private Sub btnResetVideoConfFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnResetVideoConfFile.Click

        't[Ȃ΁A~B
        If m_bInsFreerun Then
            Timer1.Stop()
            Timer1.Enabled = False
            btnGrab.Enabled = True
            btnFreerun.Text = "Freerun"
            m_bInsFreerun = False
        End If

        'rfIfoCX̑I
        setVideoConfFile()

    End Sub

    'rfIݒt@CI
    Private Sub setVideoConfFile()

        Dim intCaptureNum As Integer   'Lv`{[h̖
        Dim i As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile  'rfIݒt@C

        'rfIݒt@C̑I
        m_strVideoConfFilePath = ""
        If frmVideoConf.ShowDialog() = Windows.Forms.DialogResult.OK Then
            m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
        End If

        Try
            If m_strVideoConfFilePath.Length <> 0 Then

                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                If m_blnVideoOpened = True Then
                    'rfIfoCXI[vĂꍇ͈UN[Y܂
                    AxFvxVideo1.CloseDevice()
                End If

                'rfIfoCX̃I[vԕێϐ̏
                m_blnVideoOpened = False
                btnGrab.Enabled = False
                btnFreerun.Enabled = False

                'ItZbg
                m_bCanOffSet = False
                txtOffset.Enabled = False
                trcOffSet.Enabled = False
                'I
                m_bCanExposure = False
                txtExposure.Enabled = False
                trcExposure.Enabled = False
                'HWQl
                m_blnCanHWBinarize = False
                cmbImageType.Enabled = False
                txtBinLevel.Enabled = False
                trcBinLevel.Enabled = False

                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath
                'foCXI[v
                AxFvxVideo1.OpenDevice()

                'VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                '4J荞݂ŝŁA4̉摜̈pӂ܂
                AxFvxImage1.ImageNum = 4

                '4ch荞
                AxFvxVideo1.GetSimGrab(i)
                If i <> 4 Then AxFvxVideo1.SetSimGrab(4)

                'GrabSync/GrabASync\bhłImegeTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂ
                'i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

                '捞
                AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())

                'rfIfoCX̏ԂL
                m_blnVideoOpened = True
                btnGrab.Enabled = True
                btnFreerun.Enabled = True

                'Lv`{[h擾
                AxFvxVideo1.GetCaptureNum(intCaptureNum)

                '`l
                'gpłch 0`((I[vĂ{[h)*({[h̃J̓RlN^)-1) ł
                'FVC02̃J̓RlN^2łB
                cmbChannel.Items.Clear()
                For i = 0 To (intCaptureNum * 2) / 4 - 1
                    cmbChannel.Items.Add("CH" + (i * 4).ToString("0") + "-" + (i * 4 + 3).ToString("0"))
                Next
                cmbChannel.SelectedIndex = 0

                'gK[h
                cmbTrigger.Items.Clear()
                cmbTrigger.Items.Add("m[}")
                cmbTrigger.Items.Add("gK(SW)")
                cmbTrigger.Items.Add("OgK(Ext)")
                cmbTrigger.SelectedIndex = 0

                '捞摜
                cmbImageType.Items.Clear()
                cmbImageType.Items.Add("")
                cmbImageType.Items.Add("1f1bit2l")
                cmbImageType.Items.Add("1f8bit2l(0/255)")
                cmbImageType.Items.Add("1f8bit臒lȏ255")
                cmbImageType.SelectedIndex = 0

                'FlagON
                m_bCanOffSet = True
                m_bCanExposure = True
                m_blnCanHWBinarize = True

                ' rfIItZbg
                If (m_bCanOffSet) Then
                    AxFvxVideo1.GetVideoOffset(i)
                    trcOffSet.Value = i
                    txtOffset.Text = i
                    txtOffset.Enabled = True
                    trcOffSet.Enabled = True
                End If

                ' I
                If (m_bCanExposure) Then
                    AxFvxVideo1.GetExposureTime(i)
                    trcExposure.Value = i / 1000
                    txtExposure.Text = i / 1000
                    txtExposure.Enabled = True
                    trcExposure.Enabled = True
                End If

                ' HWQl
                If (m_blnCanHWBinarize) Then
                    cmbImageType.Enabled = True
                    AxFvxVideo1.GetBinarizeThreshold(i)
                    trcBinLevel.Value = i
                    txtBinLevel.Text = i
                    txtBinLevel.Enabled = True
                    trcBinLevel.Enabled = True
                End If
            End If

        Catch

            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")

        Finally

            'ʂ̐
            AxFvxImage1.CurrentNo = 0
            AxFvxDisplayEx1.CreateDisplay()
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
            AxFvxImage1.CurrentNo = 1
            AxFvxDisplayEx2.CreateDisplay()
            AxFvxDisplayEx2.DrawImage(AxFvxImage1.GetOcx())
            AxFvxImage1.CurrentNo = 2
            AxFvxDisplayEx3.CreateDisplay()
            AxFvxDisplayEx3.DrawImage(AxFvxImage1.GetOcx())
            AxFvxImage1.CurrentNo = 3
            AxFvxDisplayEx4.CreateDisplay()
            AxFvxDisplayEx4.DrawImage(AxFvxImage1.GetOcx())
            AxFvxImage1.CurrentNo = 0

        End Try

    End Sub

    'FvxVideoG[bZ[W擾
    Private Function GetFvxVideoErrMsg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 6001
                GetFvxVideoErrMsg = "\ȂG[łB"
            Case 6002
                GetFvxVideoErrMsg = "T|[gĂ܂B"
            Case 6005
                GetFvxVideoErrMsg = "p[^słB"
            Case 6010
                GetFvxVideoErrMsg = "̊mۂɎs܂B"
            Case 6015
                GetFvxVideoErrMsg = "DLLt@C݂܂B"
            Case 6020
                GetFvxVideoErrMsg = "foCX̃I[vɎs܂B"
            Case 6021
                GetFvxVideoErrMsg = "ɃI[vĂ܂B"
            Case 6030
                GetFvxVideoErrMsg = "Lv`I[vĂ܂B"
            Case 6031
                GetFvxVideoErrMsg = "Lv`{[h܂B"
            Case 6032
                GetFvxVideoErrMsg = "foCXIDsłB"
            Case 6037
                GetFvxVideoErrMsg = "GrabASynĉߏs܂B"
            Case 6040
                GetFvxVideoErrMsg = "摜荞݂Ɏs܂B"
            Case 6041
                GetFvxVideoErrMsg = "^CAEg܂B"
            Case 6042
                GetFvxVideoErrMsg = "摜f[^słB"
            Case 6043
                GetFvxVideoErrMsg = "摜͂Ɏs܂B"
            Case 6044
                GetFvxVideoErrMsg = "Xe[^X`FbNɎs܂B"
            Case 6045
                GetFvxVideoErrMsg = "ݒ肵摜TCYvĂȂAWOIEBhEPݒ肳Ă܂B"
            Case 6046
                GetFvxVideoErrMsg = "摜̃bNɎs܂B"
            Case 6047
                GetFvxVideoErrMsg = "摜̃AbNɎs܂B"
            Case 6048
                GetFvxVideoErrMsg = "nhsłB"
            Case 6052
                GetFvxVideoErrMsg = "[h̕ύXɎs܂B"
            Case 6053
                GetFvxVideoErrMsg = "[h̎擾Ɏs܂B"
            Case 6054
                GetFvxVideoErrMsg = "Lv`TCY̕ύXɎs܂B"
            Case 6055
                GetFvxVideoErrMsg = "摜TCY擾Ɏs܂B"
            Case 6056
                GetFvxVideoErrMsg = "Lv`ItZbgݒɎs܂B"
            Case 6058
                GetFvxVideoErrMsg = "rfIItZbg̐ݒɎs܂B"
            Case 6060
                GetFvxVideoErrMsg = "IԂ̐ݒɎs܂B"
            Case 6061
                GetFvxVideoErrMsg = "IԂ̎擾Ɏs܂B"
            Case 6062
                GetFvxVideoErrMsg = "^CAEg̕ύXɎs܂B"
            Case 6063
                GetFvxVideoErrMsg = "^CAEg擾Ɏs܂B"
            Case 6066
                GetFvxVideoErrMsg = "2lݒɎs܂B"
            Case 6074
                GetFvxVideoErrMsg = "gK[h̕ύXɎs܂B"
            Case 6080
                GetFvxVideoErrMsg = "rfIݒt@C܂B"
            Case 6081
                GetFvxVideoErrMsg = "rfIݒt@CpXݒ肳Ă܂B"
            Case 6085
                GetFvxVideoErrMsg = "JR}ht@C܂B"
            Case 6100
                GetFvxVideoErrMsg = "SIOR}hgpł܂B"
            Case 6101
                GetFvxVideoErrMsg = "SIOR}h܂B"
            Case 6102
                GetFvxVideoErrMsg = "SIO^CAEg܂BJڑĂ邱ƂmFĂB"
            Case 6150
                GetFvxVideoErrMsg = "[Jobt@ȏ̃TCYw肵Ă܂B"
            Case 6200
                GetFvxVideoErrMsg = "JڑĂȂAdĂ܂B"
            Case 6201
                GetFvxVideoErrMsg = "J̏Ɏs܂B"
            Case 6202
                GetFvxVideoErrMsg = "JtbVɎs܂B"
            Case 6203
                GetFvxVideoErrMsg = "JZ[uɎs܂B"
            Case 6204
                GetFvxVideoErrMsg = "J[hɎs܂B"
            Case 6210
                GetFvxVideoErrMsg = "BitWidthݒɎs܂B"
            Case 6211
                GetFvxVideoErrMsg = "Bit擾Ɏs܂B"
            Case 6212
                GetFvxVideoErrMsg = "CC̐ݒɎs܂B"
            Case 6213
                GetFvxVideoErrMsg = "CC̎擾Ɏs܂B"
            Case 6214
                GetFvxVideoErrMsg = "SIO[hݒɎs܂B"
            Case 6216
                GetFvxVideoErrMsg = "SIOp[^̐ݒɎs܂B"
            Case 6217
                GetFvxVideoErrMsg = "SIOp[^̎擾Ɏs܂B"
            Case 6218
                GetFvxVideoErrMsg = "WOIEBhE̐ݒɎs܂B"
            Case 6220
                GetFvxVideoErrMsg = "WOI Enable̐ݒɎs܂B"
            Case 6222
                GetFvxVideoErrMsg = "WOI[h̐ݒɎs܂B"
            Case 6221
                GetFvxVideoErrMsg = "WOI Enable̎擾Ɏs܂B"
            Case 6223
                GetFvxVideoErrMsg = "WOI[h̎擾Ɏs܂B "
            Case 6360
                GetFvxVideoErrMsg = "摜荞݂Ɏs܂B"
            Case Else
                GetFvxVideoErrMsg = "sȃG["
        End Select

    End Function

    '荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        Dim dblTime As Double

        Try

            AxFvxPerformanceCounter1.StartCount()   'ԑJn
            '捞
            AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
            AxFvxPerformanceCounter1.StopCount(dblTime)    'ԑI

        Catch

            'G[
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("捞G[ " + GetFvxVideoErrMsg(intErr), MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "G[")

        Finally

            '荞񂾉摜ʂɕ\
            AxFvxImage1.CurrentNo = 0
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
            AxFvxImage1.CurrentNo = 1
            AxFvxDisplayEx2.DrawImage(AxFvxImage1.GetOcx())
            AxFvxImage1.CurrentNo = 2
            AxFvxDisplayEx3.DrawImage(AxFvxImage1.GetOcx())
            AxFvxImage1.CurrentNo = 3
            AxFvxDisplayEx4.DrawImage(AxFvxImage1.GetOcx())
            AxFvxImage1.CurrentNo = 0
            txtGrabTime.Text = dblTime.ToString("0.00ms")

        End Try

    End Sub

    'rfI`l
    Private Sub cmbChannel_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbChannel.SelectedIndexChanged

        If m_blnVideoOpened Then
            Try
                AxFvxVideo1.SetChannel(cmbChannel.SelectedIndex * 2)
            Catch
                Dim intErr As Integer
                'G[
                AxFvxVideo1.GetErrReport(intErr)
                MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
            End Try
        End If

    End Sub

    'gK[h
    Private Sub cmbTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbTrigger.SelectedIndexChanged
        Try
            If m_blnVideoOpened Then
                AxFvxVideo1.SetTrigger(cmbTrigger.SelectedIndex)
            End If
        Catch
            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
        End Try

    End Sub

    'rfIItZbg
    Private Sub trcOffSet_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trcOffSet.Scroll
        Try
            If m_blnVideoOpened And m_bCanOffSet Then
                txtOffset.Text = trcOffSet.Value
                AxFvxVideo1.SetVideoOffset(trcOffSet.Value)
            End If
        Catch
            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
        End Try

    End Sub

    'IԐݒ
    Private Sub trcExposure_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trcExposure.Scroll
        Try
            If m_blnVideoOpened And m_bCanExposure Then
                txtExposure.Text = trcExposure.Value
                AxFvxVideo1.SetExposureTime(trcExposure.Value * 1000)
            End If
        Catch
            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
        End Try

    End Sub

    'HWQlon/off
    Private Sub cmbImageType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbImageType.SelectedIndexChanged
        Try
            If m_blnVideoOpened And m_blnCanHWBinarize Then
                AxFvxVideo1.SetBinarizeMode(cmbImageType.SelectedIndex)
                AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())
            End If
        Catch
            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
        End Try

    End Sub

    't[JnE~
    Private Sub btnFreerun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFreerun.Click
        If m_bInsFreerun Then
            Timer1.Enabled = False
            btnGrab.Enabled = True
            btnFreerun.Text = "Freerun"
        Else
            Timer1.Interval = 100
            Timer1.Start()
            btnGrab.Enabled = False
            btnFreerun.Text = "Stop"
        End If

        m_bInsFreerun = Not m_bInsFreerun
        Application.DoEvents()

    End Sub

    't[
    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim dblTime As Double

        Timer1.Stop()

        Try
            If m_blnVideoOpened Then
                AxFvxPerformanceCounter1.StartCount()
                '捞
                AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
                AxFvxPerformanceCounter1.StopCount(dblTime)
            End If

            Timer1.Enabled = True
        Catch

            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("捞G[ " + GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
            Timer1.Enabled = False
            btnGrab.Enabled = True
            btnFreerun.Text = "Freerun"
            m_bInsFreerun = False
        Finally

            '摜\
            AxFvxImage1.CurrentNo = 0
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
            AxFvxImage1.CurrentNo = 1
            AxFvxDisplayEx2.DrawImage(AxFvxImage1.GetOcx())
            AxFvxImage1.CurrentNo = 2
            AxFvxDisplayEx3.DrawImage(AxFvxImage1.GetOcx())
            AxFvxImage1.CurrentNo = 3
            AxFvxDisplayEx4.DrawImage(AxFvxImage1.GetOcx())
            AxFvxImage1.CurrentNo = 0
            txtGrabTime.Text = dblTime.ToString("0.00ms")

        End Try

    End Sub

    'HWQlxݒ
    Private Sub trcBinLevel_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trcBinLevel.Scroll
        Try
            If m_blnVideoOpened And m_blnCanHWBinarize Then
                txtBinLevel.Text = trcBinLevel.Value
                AxFvxVideo1.SetBinarizeTheshold(trcBinLevel.Value)
            End If
        Catch
            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")

        End Try
    End Sub
End Class
